﻿Public Class Paint
    Private _b As Brush
    Private _c As Canvas
    Private _g As Graphics
    Private _ps As Point

    Public Property g() As Graphics
        Get
            Return _g
        End Get
        Set(ByVal value As Graphics)
            _g = value
        End Set
    End Property

    Public Sub Down(ByVal pt As Point)
        _ps = pt
    End Sub

    Public Sub Move(ByVal pt As Point, ByVal pr As Integer)
        If Not _ps.IsEmpty AndAlso Not pt.IsEmpty Then
            _b.w = pr / 32
            _c.Draw(_g, _b, _ps, pt)
            _ps = pt
        End If
    End Sub

    Public Sub Up(ByVal pt As Point)
        _ps = Point.Empty
    End Sub

    Public Sub New(ByVal g As Graphics)
        _b = New Brush()
        _c = New Canvas()
        _g = g
    End Sub

    Protected Overrides Sub Finalize()
        _g.Dispose()
        MyBase.Finalize()
    End Sub
End Class
